program main !Main executable for Lentz, Piyapromdee, and Robin (2023).
  use paths
  use mpimod
  use datbyread
  use datbysim
  use cem
  use postprod
  implicit none
  integer :: i,j
  real(8),allocatable :: ini(:,:)
  real(8) :: akmout(19),stat
  integer :: myzdist(0:6),zdist(0:6)

  call mpi_ini !initialize message passing interface
  
  call readdat("time1") !input argument specifies period of estimation
  	
  call estcall

	if(master) write(6,'("All done")')  
  call mpi_term !terminate message passing interface
end program main

subroutine estcall
  use paths
  use mpimod
  use datbyread
  use cem
  use postprod
  implicit none
  integer, parameter :: capk=24,capl=14
  real(8) :: ll_BLM, ll_LPR
  integer :: i
  open(10,file=outpath//"iniguessrep.log",status='replace')
  write(10,'("output file for stochastic initial guess")')
  close(10)

  do i=1,30
  	if(master) write(6,'("Doing iteration ",i5)') i
    call cem_estim(capk,capl,"all"//inttochar(3,i),i,ll_BLM,ll_LPR)
  	if(master) then
  		open(10,file=outpath//"iniguessrep.log",status='old',access='append')
  		write(10,'(i5,f25.5)') i,ll_BLM
        write(10,'(i5,f25.5)') i,ll_LPR
  		close(10)
  	end if
  	if(master) open(10,file=outpath//"all"//inttochar(3,i)//'.log',status='replace')
  	call firmchar(10,i) !write firm characteristics at bottom of log file.
  	call workchar(10,i) !write worker characteristics at bottom of log file.
  	if(master) close(10)
  	call pklxcalc("all"//inttochar(3,i),1) !produce post-estimation outputs
    call estim_term
  end do  
end subroutine estcall
