module postprod !Post estimation production
  use cem !make the cem and estim object available. Estim also make model.mod available.
  use paths
  use mpimod !use message passing interface
  implicit none 

contains
	
	subroutine workchar(ch,seed)
		implicit none
    integer, intent(in) :: ch,seed
		real(8) :: gender(ep%k,2), edu(ep%k,3), exper(ep%k,54:80,5), tenure(ep%k,54:80,3),genbyt(ep%k,54:80,2),edubyt(ep%k,54:80,3)
		real(8) :: mygender(ep%k,2), myedu(ep%k,3), myexper(ep%k,54:80,5), mytenure(ep%k,54:80,3),mygenbyt(ep%k,54:80,2),myedubyt(ep%k,54:80,3)
		integer :: i,j,k,jj
		mygender=0.d0
		myedu=0.d0
		myexper=0.d0
		mytenure=0.d0
		myedubyt=0.d0
		mygenbyt=0.d0
		do i=1+myid,dim_I,numprocs
			if(.not. associated(work(i)%first)) cycle
			if(work(i)%male) then
				mygender(:,1)=mygender(:,1)+pprobw(i,:)
			else
				mygender(:,2)=mygender(:,2)+pprobw(i,:)
			end if
			if(work(i)%edu<12) myedu(:,1)=myedu(:,1)+pprobw(i,:)
			if(work(i)%edu==12) myedu(:,2)=myedu(:,2)+pprobw(i,:)
			if(work(i)%edu>12) myedu(:,3)=myedu(:,3)+pprobw(i,:)			
			do j=54,80
				this=>null()
				call find_t(work(i)%first,yrtoweek(j))
				if(.not. associated(this)) cycle			
				if(this%end>=yrtoweek(j) .and. this%strt<=yrtoweek(j)) then
					myexper(:,j,1)=myexper(:,j,1)+pprobw(i,:)
					myexper(:,j,2+expcat(j-work(i)%gradyr))=myexper(:,j,2+expcat(j-work(i)%gradyr))+pprobw(i,:)
					mytenure(:,j,1)=mytenure(:,j,1)+pprobw(i,:)
					mytenure(:,j,2+tencat(yrtoweek(j)-this%strt+this%ten))=mytenure(:,j,2+tencat(yrtoweek(j)-this%strt+this%ten))+pprobw(i,:)
					if(work(i)%male) then
						mygenbyt(:,j,1)=mygenbyt(:,j,1)+pprobw(i,:)
					else
						mygenbyt(:,j,2)=mygenbyt(:,j,2)+pprobw(i,:)
					end if
					if(work(i)%edu<12) myedubyt(:,j,1)=myedubyt(:,j,1)+pprobw(i,:)
					if(work(i)%edu==12) myedubyt(:,j,2)=myedubyt(:,j,2)+pprobw(i,:)
					if(work(i)%edu>12) myedubyt(:,j,3)=myedubyt(:,j,3)+pprobw(i,:)			
				end if					
			end do
		end do
		call mpi_reduce(mygender,gender,ep%k*2,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
		call mpi_reduce(myedu,edu,ep%k*3,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
		call mpi_reduce(myexper,exper,ep%k*5*27,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
		call mpi_reduce(mytenure,tenure,ep%k*3*27,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
		call mpi_reduce(mygenbyt,genbyt,ep%k*2*27,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
		call mpi_reduce(myedubyt,edubyt,ep%k*3*27,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
		if(master) then
			do j=54,80
				do i=1,ep%k
					genbyt(i,j,:)=genbyt(i,j,:)/sum(genbyt(i,j,:))
					edubyt(i,j,:)=edubyt(i,j,:)/sum(edubyt(i,j,:))
				end do
			end do

			write(ch,'("Gender:")')
			write(ch,'(a5,2a15)') "k","Male","Female"
			write(ch,'(i5,2f15.5)') (i,gender(i,1)/(gender(i,1)+gender(i,2)),gender(i,2)/(gender(i,1)+gender(i,2)),i=1,ep%k)

            open(10,file=outpath//"gender"//inttochar(3,seed)//'.txt',status='replace')
			  write(10,'(a5,2a15)') "k","Male","Female"
			  write(10,'(i5,2f15.5)') (i,gender(i,1)/(gender(i,1)+gender(i,2)),gender(i,2)/(gender(i,1)+gender(i,2)),i=1,ep%k)
            close(10)

			write(ch,'(" ")')
			write(ch,'("Education:")')
			write(ch,'(a5,3a15)') "k","Edu<12","Edu=12","Edu>12"			
			write(ch,'(i5,3f15.5)') (i,edu(i,1)/sum(edu(i,:)),edu(i,2)/sum(edu(i,:)),edu(i,3)/sum(edu(i,:)),i=1,ep%k)

            open(10,file=outpath//"education"//inttochar(3,seed)//'.txt',status='replace')
			  write(10,'(a5,3a15)') "k","Edu<12","Edu=12","Edu>12"			
			  write(10,'(i5,3f15.5)') (i,edu(i,1)/sum(edu(i,:)),edu(i,2)/sum(edu(i,:)),edu(i,3)/sum(edu(i,:)),i=1,ep%k)
            close(10)

			write(ch,'(" ")')
			do jj=0,3
				write(ch,'("Fraction of exp=",i1," by time:")'), jj
				write(ch,'(a5,27i10)') "k",(j,j=54,80)			
				write(ch,'(i5,27f10.3)') (i,(exper(i,j,2+jj)/exper(i,j,1),j=54,80),i=1,ep%k)
				write(ch,'(" ")')
            end do

            open(10,file=outpath//"experience"//inttochar(3,seed)//'.txt',status='replace')

            do jj=0,3
				write(10,'("Fraction of exp=",i1," by time:")'), jj
				write(10,'(a5,27i10)') "k",(j,j=54,80)			
				write(10,'(i5,27f10.3)') (i,(exper(i,j,2+jj)/exper(i,j,1),j=54,80),i=1,ep%k)
            end do

           close(10)

			do jj=0,1
				write(ch,'("Fraction of tenure=",i1," by time:")'), jj
				write(ch,'(a5,27i10)') "k",(j,j=54,80)			
				write(ch,'(i5,27f10.3)') (i,(tenure(i,j,2+jj)/tenure(i,j,1),j=54,80),i=1,ep%k)
				write(ch,'(" ")')
            end do

            open(10,file=outpath//"tenure"//inttochar(3,seed)//'.txt',status='replace')

            do jj=0,1
				write(10,'("Fraction of tenure=",i1," by time:")'), jj
				write(10,'(a5,27i10)') "k",(j,j=54,80)			
				write(10,'(i5,27f10.3)') (i,(tenure(i,j,2+jj)/tenure(i,j,1),j=54,80),i=1,ep%k)
            end do

           close(10)

			write(ch,'("Fraction of men by time:")')
			write(ch,'(a5,27i10)') "k",(j,j=54,80)			
			write(ch,'(i5,27f10.3)') (i,(genbyt(i,j,1),j=54,80),i=1,ep%k)

            open(10,file=outpath//"men_by_time"//inttochar(3,seed)//'.txt',status='replace')

              write(10,'(a5,27i10)') "k",(j,j=54,80)			
			  write(10,'(i5,27f10.3)') (i,(genbyt(i,j,1),j=54,80),i=1,ep%k)

            close(10)

			write(ch,'(" ")')
			write(ch,'("Fraction of women by time:")')
			write(ch,'(a5,27i10)') "k",(j,j=54,80)			
			write(ch,'(i5,27f10.3)') (i,(genbyt(i,j,2),j=54,80),i=1,ep%k)

            open(10,file=outpath//"women_by_time"//inttochar(3,seed)//'.txt',status='replace')
              write(10,'(a5,27i10)') "k",(j,j=54,80)			
			  write(10,'(i5,27f10.3)') (i,(genbyt(i,j,2),j=54,80),i=1,ep%k)
            close(10)

			write(ch,'(" ")')
			write(ch,'("Fraction of low edu by time:")')
			write(ch,'(a5,27i10)') "k",(j,j=54,80)			
			write(ch,'(i5,27f10.3)') (i,(edubyt(i,j,1),j=54,80),i=1,ep%k)

            open(10,file=outpath//"lowed_by_time"//inttochar(3,seed)//'.txt',status='replace')
              write(10,'(a5,27i10)') "k",(j,j=54,80)			
			  write(10,'(i5,27f10.3)') (i,(edubyt(i,j,1),j=54,80),i=1,ep%k)
            close(10)

			write(ch,'(" ")')
			write(ch,'("Fraction of mid edu by time:")')
			write(ch,'(a5,27i10)') "k",(j,j=54,80)			
			write(ch,'(i5,27f10.3)') (i,(edubyt(i,j,2),j=54,80),i=1,ep%k)

            open(10,file=outpath//"mided_by_time"//inttochar(3,seed)//'.txt',status='replace')
              write(10,'(a5,27i10)') "k",(j,j=54,80)			
			  write(10,'(i5,27f10.3)') (i,(edubyt(i,j,2),j=54,80),i=1,ep%k)
            close(10)

			write(ch,'(" ")')
			write(ch,'("Fraction of high edu by time:")')
			write(ch,'(a5,27i10)') "k",(j,j=54,80)			
			write(ch,'(i5,27f10.3)') (i,(edubyt(i,j,3),j=54,80),i=1,ep%k)

            open(10,file=outpath//"highed_by_time"//inttochar(3,seed)//'.txt',status='replace')
              write(10,'(a5,27i10)') "k",(j,j=54,80)			
			  write(10,'(i5,27f10.3)') (i,(edubyt(i,j,3),j=54,80),i=1,ep%k)
            close(10)
        end if !end of master

        ! get each slave to output prob types
           open(10,file=outpath//"worker_type"//inttochar(3,seed)//'_'//inttochar(3,myid)//'.txt',status='replace')
              write(10,'(2a10)') "ID", "prob of each k"
              write(10,'(i10,<ep%k>f15.8)') (work(i)%id,(pprobw(i,k),k=1,ep%k), i=1+myid,dim_I,numprocs)
           close(10) 
		
		contains
			function tencat(inp) result(res)
				integer, intent(in) :: inp
				integer :: res
				if(inp<100) then
					res=0.d0
				else
					res=1.d0
				end if
			end function tencat

			function expcat(inp) result(res)
				integer, intent(in) :: inp
				integer :: res
				res=0
				if(inp>5) res=res+1
				if(inp>10) res=res+1
				if(inp>15) res=res+1
			end function expcat
   end subroutine workchar
  
   subroutine firmchar(ch,seed)
    implicit none
    integer, intent(in) :: ch, seed
    integer :: j, i
    integer :: fcount(ep%l)
    real(8), dimension(ep%l) :: avgsize
    real(8) :: xdens(ep%l,hetdim),kdens(ep%l,ep%k)
    real(8) :: sector(ep%l,0:2), minput(4,dim_J), ay_size(ep%l),ay_inflow(ep%l),ay_outflow(ep%l),ay_age(ep%l)

    real(8) :: var_size(ep%l), var_inflow(ep%l), var_outflow(ep%l), foutput(dim_J,7)
    fcount=0
    sector=0.d0
    avgsize=0.d0

    !averae per year measures
    ay_size=0.d0
    ay_inflow=0.d0
    ay_outflow=0.d0
    ay_age=0.d0
    var_size=0.d0
    var_inflow=0.d0
    var_outflow=0.d0

    !firm output matrix
    foutput=0.d0
    minput=0.d0

    !means
    call mobinput(minput)
    do j=1,dim_J
       if(firmtype(j)>0) then
          fcount(firmtype(j))=fcount(firmtype(j))+1
          sector(firmtype(j),firm(j)%sector)=sector(firmtype(j),firm(j)%sector)+1.d0
          avgsize(firmtype(j))=avgsize(firmtype(j))+firmsize(j)

          ay_size(firmtype(j))=ay_size(firmtype(j))+minput(1,j)
          ay_inflow(firmtype(j))=ay_inflow(firmtype(j))+minput(2,j)
          ay_outflow(firmtype(j))=ay_outflow(firmtype(j))+minput(3,j)
          ay_age(firmtype(j))=ay_age(firmtype(j))+minput(4,j)

          foutput(j,1)=firmtype(j)  !firm type
          foutput(j,2)=firmsize(j)  !total spells
          foutput(j,3)=minput(1,j)  !average size per year
          foutput(j,4)=minput(2,j)  !average inflow per year
          foutput(j,5)=minput(3,j)  !average outflow per year
          foutput(j,6)=minput(4,j)  !age
       else
          foutput(j,1)=firmtype(j)
       end if
    end do
    do j=1,ep%l
       sector(j,:)=sector(j,:)/dble(fcount(j))
       avgsize(j)=avgsize(j)/dble(fcount(j))
       ay_size(j)=ay_size(j)/dble(fcount(j))
       ay_inflow(j)=ay_inflow(j)/dble(fcount(j))
       ay_outflow(j)=ay_outflow(j)/dble(fcount(j))
       ay_age(j)=ay_age(j)/dble(fcount(j))
    end do

    !variances
    do j=1,dim_J
       if(firmtype(j)>0) then
          var_size(firmtype(j))=var_size(firmtype(j))+(minput(1,j)-ay_size(firmtype(j)))**2
          var_inflow(firmtype(j))=var_inflow(firmtype(j))+(minput(2,j)-ay_inflow(firmtype(j)))**2
          var_outflow(firmtype(j))=var_outflow(firmtype(j))+(minput(3,j)-ay_outflow(firmtype(j)))**2
       end if
    end do

    do j=1,ep%l
       var_size(j)=var_size(j)/dble(fcount(j))
       var_inflow(j)=var_inflow(j)/dble(fcount(j))
       var_outflow(j)=var_outflow(j)/dble(fcount(j))
    end do

  
    if(master) then
        write(ch,'("Firm characteristics")')
        write(ch,'("--------------------")')
        write(ch,'(a10,12a20)') "Type","sector=0 no info","sector=1 public","sector=2 private","Number of workers","Number of firms in type", "Avg spells per year","Avg inflow per year","Avg outflow per year", "age", " Var spells per year","Var inflow per year","Var outflow per year"
        write(ch,'(i10,4f25.5,i25,7f25.5)') ((j,sector(j,0),sector(j,1),sector(j,2),avgsize(j),fcount(j),ay_size(j),ay_inflow(j),ay_outflow(j),ay_age(j),var_size(j),var_inflow(j),var_outflow(j)),j=1,ep%l)

      open(10,file=outpath//"firmchar"//inttochar(3,seed)//'.txt',status='replace')
        write(10,'("Firm characteristics")')
        write(10,'(a10,12a20)') "Type","sector=0 no info","sector=1 public","sector=2 private","Number of workers","Number of firms in type", "Avg spells per year","Avg inflow per year","Avg outflow per year", "age"," Var spells per year","Var inflow per year","Var outflow per year"
        write(10,'(i10,4f25.5,i25,7f25.5)') ((j,sector(j,0),sector(j,1),sector(j,2),avgsize(j),fcount(j),ay_size(j),ay_inflow(j),ay_outflow(j),ay_age(j),var_size(j),var_inflow(j),var_outflow(j)),j=1,ep%l)
      close(10)

      open(10,file=outpath//"firm_matrix"//inttochar(3,seed)//'.txt',status='replace')
        write(10,'(10a20)') "ID", "Type","Total spells", "Avg spells p.a.","Avg inflow","Avg outflow", "Age","industry","sector"
        write(10,'(i5,6f15.8,2i2)') ((firm(j)%id, (foutput(j,i), i=1,6),firm(j)%industry,firm(j)%sector), j=1,dim_J)
      close(10)
    end if
  end subroutine firmchar

  subroutine pklxcalc(outname,simrep)
    character(*), intent(in) :: outname
	integer, intent(in) :: simrep
    integer :: i,ii,j
    integer :: Ix(hetdim),mobIx(hetdim),myIx(hetdim),mymobIx(hetdim) !number of observations for each x category: age and short versus long tenu
    integer :: Iy(sdhetdim),myIy(sdhetdim) !number of observations for each y category: age, short, mid and long ten
    real(8) :: mypklx(hetdim,ep%k,ep%l),pklx(hetdim,ep%k,ep%l),mobpklx(hetdim,ep%k,0:ep%l) !p_{kl}(x) in variance decomposition
    real(8) :: mymobpklx(hetdim,ep%k,0:ep%l), mypkly(sdhetdim,ep%k,ep%l),pkly(sdhetdim,ep%k,ep%l)
    real(8), dimension(hetdim) :: myew,myww,ew,ww,varw
    real(8), dimension(sdhetdim) :: myewy,mywwy,ewy,wwy,varwy
    real(8) :: wwtot,ewtot,varwtot
    real(8) :: wwtoty,ewtoty
    real(8) :: linstat(hetdim,7), a(ep%k),b(ep%l), linstaty(sdhetdim,2)

    mypklx=0.d0

    mypkly=0.d0
    mymobpklx=0.d0
    myIx=0

    myIy=0.d0
    mymobIx=0
    myew=0.d0
    myww=0.d0

    myewy=0.d0
    mywwy=0.d0
    do i=1+myid,dim_I,numprocs
       if(associated(work(i)%first)) then
          call pklcount(work(i)%first)
       end if
    end do
    call mpi_allreduce(mypklx,pklx,ep%k*ep%l*hetdim,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)

    call mpi_allreduce(mypkly,pkly,ep%k*ep%l*sdhetdim,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
    call mpi_allreduce(mymobpklx,mobpklx,ep%k*(1+ep%l)*hetdim,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
    call mpi_allreduce(myIx,Ix,hetdim,mpi_integer,mpi_sum,mpi_comm_world,ierr)

    call mpi_allreduce(myIy,Iy,sdhetdim,mpi_integer,mpi_sum,mpi_comm_world,ierr)
    call mpi_allreduce(mymobIx,mobIx,hetdim,mpi_integer,mpi_sum,mpi_comm_world,ierr)
    call mpi_allreduce(myew,ew,hetdim,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
    call mpi_allreduce(myww,ww,hetdim,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)

    call mpi_allreduce(myewy,ewy,sdhetdim,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
    call mpi_allreduce(mywwy,wwy,sdhetdim,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)

    ewtot=sum(ew)
    wwtot=sum(ww)
    ew=ew/dble(Ix)
    ewtot=ewtot/sum(dble(Ix))
    varw=ww/dble(Ix)-ew*ew
    varwtot=wwtot/sum(dble(Ix))-ewtot*ewtot

    ewtoty=sum(ewy)
    wwtoty=sum(wwy)
    ewy=ewy/dble(Iy)
    ewtoty=ewtoty/sum(dble(Iy))
    varwy=wwy/dble(Iy)-ewy*ewy
    
    do i=1,hetdim
       pklx(i,:,:)=pklx(i,:,:)/dble(Ix(i))
       mobpklx(i,:,:)=mobpklx(i,:,:)/dble(mobIx(i))

       call linproj(i,linstat(i,:),a,b)
    end do

    do i=1,sdhetdim 
       pkly(i,:,:)=pkly(i,:,:)/dble(Iy(i))
       call linprojy(i,linstaty(i,:))
    end do

    if(master) then
       open(10,file=outpath//outname//'_pkl.txt',status='replace')
       write(10,'(3i5)') hetdim, ep%k, ep%l
       do i=1,hetdim
          write(10,'(<ep%l>f15.8)') ((pklx(i,ii,j),j=1,ep%l),ii=1,ep%k)
       end do
       close(10)

       open(10,file=outpath//outname//'_pkly.txt',status='replace')
       write(10,'(3i5)') sdhetdim, ep%k, ep%l
       do i=1,sdhetdim
          write(10,'(<ep%l>f15.8)') ((pkly(i,ii,j),j=1,ep%l),ii=1,ep%k)
       end do
       close(10)

       open(10,file=outpath//outname//'_mobpkl.txt',status='replace')
       write(10,'(3i5)') hetdim, ep%k, ep%l
       do i=1,hetdim
          write(10,'(<ep%l+1>f15.8)') ((mobpklx(i,ii,j),j=0,ep%l),ii=1,ep%k)
       end do
       close(10)
	   
	   open(11,file=outpath//outname//'_a.txt',status='replace')
	   write(11,'(f12.8)') a(1:ep%k)
       close(11)
	   
	   open(11,file=outpath//outname//'_b.txt',status='replace')
       write(11,'(f12.8)') b(1:ep%l)
       close(11)
	   
       open(14,file=outpath//outname//'_hetdist.txt',status='replace')
       write(14,'(i5,2f20.8)') (i,dble(Ix(i))/sum(dble(Ix)),dble(mobIx(i))/sum(dble(mobIx)),i=1,hetdim)
       close(14)

       open(14,file=outpath//outname//'_hetdisty.txt',status='replace')
       write(14,'(i5,f20.8)') (i,dble(Iy(i))/sum(dble(Iy)),i=1,sdhetdim)
       close(14)
       
	   if(simrep==1) then
		   open(14,file=outpath//outname//'_datvar.txt',status='replace')
		   write(14,'(13a14)') " "," ","    E[lnw]","   Var[lnw]","     E[mu]","     Var[mu]","  E[sigma^2]","  Var[a(k)]","  Var[b(l)]","  2*Cov[a,b]","Var[mu_tilde]","   Sum(6-9)","   Sum(4-5)"
		   write(14,'(2i14,11f14.5)') (simrep,i, ew(i), varw(i),(linstat(i,j),j=1,7),sum(linstat(i,4:7)),linstat(i,2)+linstat(i,3), i=1,hetdim)
		   close(14)
	   else
		   open(14,file=outpath//outname//'_datvar.txt',status='old',access='append')
		   write(14,'(2i14,11f14.5)') (simrep,i, ew(i), varw(i),(linstat(i,j),j=1,7),sum(linstat(i,4:7)),linstat(i,2)+linstat(i,3), i=1,hetdim)
		   close(14)
       end if       

       if(simrep==1) then
		   open(14,file=outpath//outname//'_datvary.txt',status='replace')
		   write(14,'(6a14)') " "," ","    E[lnw]","   Var[lnw]","     E[mu]","     Var[mu]"
		   write(14,'(2i14,4f14.5)') (simrep,i, ewy(i), varwy(i), (linstaty(i,j),j=1,2), i=1,sdhetdim)
		   close(14)
	   else
		   open(14,file=outpath//outname//'_datvary.txt',status='old',access='append')
		   write(14,'(2i14,4f14.5)') (simrep,i, ewy(i), varwy(i), (linstaty(i,j),j=1,2), i=1,sdhetdim)
		   close(14)
	   end if
    end if
    
  contains
    recursive subroutine pklcount(mysp)
      type(spell), pointer :: mysp
      integer :: i,k
      do i=1,size(mysp%wage)
      	 mymobIx(hetmap(mysp,i))=mymobIx(hetmap(mysp,i))+1
      	 if(mysp%fid>0) then
            myIx(hetmap(mysp,i))=myIx(hetmap(mysp,i))+1

            myIy(sdhetmap(mysp,i))=myIy(sdhetmap(mysp,i))+1
            myew(hetmap(mysp,i))=myew(hetmap(mysp,i))+mysp%wage(i)
            myww(hetmap(mysp,i))=myww(hetmap(mysp,i))+mysp%wage(i)*mysp%wage(i)

            myewy(sdhetmap(mysp,i))=myewy(sdhetmap(mysp,i))+mysp%wage(i)
            mywwy(sdhetmap(mysp,i))=mywwy(sdhetmap(mysp,i))+mysp%wage(i)*mysp%wage(i)
         end if
         do k=1,ep%k
            mymobpklx(hetmap(mysp,i),k,firmtype(mysp%fid))=mymobpklx(hetmap(mysp,i),k,firmtype(mysp%fid))+pprobw(mysp%wid,k)
            if(mysp%fid>0) mypklx(hetmap(mysp,i),k,firmtype(mysp%fid))=mypklx(hetmap(mysp,i),k,firmtype(mysp%fid))+pprobw(mysp%wid,k)

            if(mysp%fid>0) mypkly(sdhetmap(mysp,i),k,firmtype(mysp%fid))=mypkly(sdhetmap(mysp,i),k,firmtype(mysp%fid))+pprobw(mysp%wid,k)
         end do
      end do
      if(associated(mysp%next)) call pklcount(mysp%next)
    end subroutine pklcount

    subroutine linproj(x,stat,a,b)
      use linmod, only : matinv_lapack
      implicit none
      integer, intent(in) :: x
      real(8), intent(out) :: stat(7),a(ep%k),b(ep%l)
      real(8),dimension(ep%k*ep%l,ep%k+ep%l-1) :: xmat
      real(8),dimension(ep%k*ep%l,ep%k*ep%l) :: w
      real(8),dimension(ep%k*ep%l,1) :: y
      real(8),dimension(ep%k+ep%l-1,1) :: res
      real(8),dimension(ep%k+ep%l-1,ep%k+ep%l-1) :: xxinv
      real(8) :: mu_res(ep%k,ep%l),mu_pred(ep%k,ep%l)
      real(8) :: tot,mubar,esig
      real(8) :: vara,varb,covab,varmu_res,varmuw
      integer :: k,l,i
    
      i=0
      a=0.d0
      xmat=0.d0
      w=0.d0
      y=0.d0
      tot=0.d0
      mubar=0.d0

      do k=1,ep%k
         do l=1,ep%l
            tot=tot+pklx(x,k,l)
            i=i+1
            y(i,1)=ep%muw(k,l,x)
            if(k>1) xmat(i,k-1)=1.d0
            xmat(i,l+ep%k-1)=1.d0
            w(i,i)=pklx(x,k,l)
            mubar=mubar+pklx(x,k,l)*ep%muw(k,l,x)
         end do
      end do
      xxinv=matmul(matmul(transpose(xmat),w),xmat)
      xxinv=matinv_lapack(xxinv)
      res=matmul(matmul(matmul(xxinv,transpose(xmat)),w),y)
      a(2:ep%k)=res(1:ep%k-1,1)
      b=res(ep%k:ep%k+ep%l-1,1)
      tot=0.d0
      do k=1,ep%k
         do l=1,ep%l
            tot=tot+pklx(x,k,l)*a(k)
         end do
      end do
	  
      a=a-tot
      tot=0.d0
      do k=1,ep%k
         do l=1,ep%l
            tot=tot+pklx(x,k,l)*b(l)
         end do
      end do

      b=b-tot
      do k=1,ep%k
         do l=1,ep%l
            mu_res(k,l)=ep%muw(k,l,x)-a(k)-b(l)-mubar
            mu_pred(k,l)=mubar+a(k)+b(l)
         end do
      end do
       
      vara=0.d0
      varb=0.d0
      covab=0.d0
      varmu_res=0.d0
      varmuw=0.d0
      esig=0.d0
      do k=1,ep%k
         do l=1,ep%l
            vara=vara+pklx(x,k,l)*(a(k)**2)
            varb=varb+pklx(x,k,l)*(b(l)**2)
            covab=covab+pklx(x,k,l)*a(k)*b(l)
            varmu_res=varmu_res+pklx(x,k,l)*(mu_res(k,l)**2)
            varmuw=varmuw+pklx(x,k,l)*(ep%muw(k,l,x)-mubar)**2
            esig=esig+pklx(x,k,l)*(ep%sigmaw(k,l,x)**2)                                           
         end do
      end do
      stat(1)=mubar
      stat(2)=varmuw
      stat(3)=esig
      stat(4)=vara
      stat(5)=varb
      stat(6)=2*covab
      stat(7)=varmu_res
    end subroutine linproj

    

    subroutine linprojy(y,staty)
      implicit none
      integer, intent(in) :: y
      real(8), intent(out) :: staty(2)
      real(8) :: mubar,varmuw
      integer :: k,l,i, x

      if(y>4) then
          x=y-4
      else
          x=y
      end if
      mubar=0.d0
      do k=1,ep%k
         do l=1,ep%l
            mubar=mubar+pkly(y,k,l)*ep%muw(k,l,x)
         end do
      end do
      varmuw=0.d0
      do k=1,ep%k
         do l=1,ep%l
            varmuw=varmuw+pkly(y,k,l)*(ep%muw(k,l,x)-mubar)**2                                         
         end do
      end do
      staty(1)=mubar
      staty(2)=varmuw
    end subroutine linprojy
  end subroutine pklxcalc
end module postprod
