module mpimod
  use mpi
  implicit none
  integer :: end_stat,ierr,myid,numprocs,status(MPI_STATUS_SIZE)
  logical :: MASTER
  real(8) :: starttime, endtime
contains
  subroutine mpi_ini
    implicit none
    integer :: i
    call MPI_INIT(ierr)
    call MPI_COMM_RANK(MPI_COMM_WORLD,myid,ierr)
    call MPI_COMM_SIZE(MPI_COMM_WORLD,numprocs,ierr)
    master=(myid==0)
    print *,'Hello. I am processor ',myid,' out of ',numprocs
    if(master) starttime=MPI_WTIME()
  end subroutine mpi_ini

  subroutine mpi_term
    implicit none
    if(master) then
       endtime=MPI_WTIME()
       print *,'Elapsed time is ', endtime-starttime, ' seconds.'
    end if
    !  print *,'I am processor ',myid, '. I am done.'
    call MPI_FINALIZE(ierr)
  end subroutine mpi_term
end module mpimod
