module datacollect
  use tools
  use modelpar_class
  implicit none
  character(6) :: fold
  character(10), dimension(5), parameter :: all_v=(/ "all007", "all006", "all001", "all007", "all003" /)
  integer, parameter :: cK(5)=(/ 24, 24, 24, 24, 24 /)
  integer, parameter :: cL(5)=(/ 14, 14, 22, 22, 22 /)
  integer, parameter :: cX=8
  integer, parameter :: cXs=12
  type(modelpar) :: par
  real(8) :: check,pe(cX),py(cxs),emp,px(cxs),varwx(cX)
  real(8), allocatable :: p(:,:,:),ak(:),bl(:),u(:,:)
contains
  subroutine datcol(t)
    integer, intent(in) :: t
    integer :: k,l,x
    real(8) :: mul
    allocate(p(cK(t),0:cL(t),cXs),ak(ck(t)),bl(cL(t)),u(cK(t),cX))
    fold="time"//inttochar(1,t)//"/"
    
    par=new_modelpar(cK(t),cL(t)) !set this to fit the file that is being used below.
    open(12,file=fold//trim(all_v(t))//'LPR.txt',status="old")
    call readmodelpar(12,par,cK(t),cL(t))
    close(12)
    open(12,file=fold//'a_muw.txt',status="old")
    read(12,*) (ak(k),k=1,cK(t))
    close(12)
    open(12,file=fold//'b_muw.txt',status="old")
    read(12,*) (bl(l),l=1,cL(t))
    close(12)
    open(12,file=fold//'varw.txt',status="old")
    read(12,*) (varwx(x),x=1,cX)
    close(12)

    !first determine joint unemployment by (k,x)
    open(12,file=fold//'graph_pklm.txt',status="old") !this contains x condtional p(k,l|x) for 8 category x.
    p=0.d0
    do x=1,cX
       do k=1,cK(t)
          read(12,*) (p(k,l,x), l=0,cl(t))
       end do
    end do
    close(12)
    u=p(:,0,1:cX)
    open(12,file=fold//trim(all_v(t))//'_hetdist.txt',status="old") !24 14    
    do x=1,cX
       read(12,('(I5,2f20.8)')) k,py(x),px(x)
    end do
    close(12)
    do x=1,cX
       u(:,x)=u(:,x)*px(x)
    end do

    !Now fill in p employment condtionally,
    p=0.d0
    open(12,file=fold//'graph_pkly.txt',status="old") !this contains p(k,l|x and l>0) for 12 category x. Only use for x>8.
    do x=1,cXs
       do k=1,cK(t)
          read(12,*) (p(k,l,x), l=1,cl(t))
       end do
    end do
    close(12)
    check=0.d0
    do x=1,cXs
       check=0.d0
       do k=1,cK(t)
          check=check+sum(p(k,:,x))
       end do
       p(:,:,x)=p(:,:,x)/check
    end do

    open(12,file=fold//trim(all_v(t))//'_hetdisty.txt',status="old") !24 14
    do x=1,cxs
       read(12,('(I5,f20.8)')) k,py(x)
    end do
    close(12)
    py=py/sum(py)

    mul=1.d0-sum(sum(u(:,:),dim=1)) !aggregate employment mass
    do x=1,cXs
       p(:,:,x)=p(:,:,x)*py(x)*mul
    end do

    !Now fill the unemployment back in
    do x=1,4
       p(:,0,x)=u(:,x)
    end do
    do x=9,12
       p(:,0,x)=u(:,x-4)
    end do
    
    check=0.d0
    do x=1,cXs
       do k=1,cK(t)
          check=check+sum(p(k,:,x))
       end do
    end do
    p=p/check !p is the fully joint distribution.
    print *,check

    open(11,file="time"//inttochar(1,t)//"est.txt",status='replace')
    call  writemodelpar_fix(11,ck(t),cl(t))
    close(11)
    deallocate(p,ak,bl,u)
  contains
    
  end subroutine datcol

  subroutine writemodelpar_fix(ch,ck,cl) !writes mypar to channel ch
    integer, intent(in) :: ch,ck,cl
    integer :: ii,jj,tt,k,l
    integer, allocatable :: kmap(:),lmap(:)
    real(8), allocatable :: muvec(:)
    real(8) :: minwage
    allocate(kmap(cK),lmap(0:cL))

    lmap(0)=0
    open(12,file=fold//'worder.txt',status="old")
    read(12,*) (kmap(k), k=1,ck)
    close(12)
    open(12,file=fold//'forder.txt',status="old")
    read(12,*) (lmap(l), l=1,cL)
    close(12)
    
    write(6,'(*(i3))') kmap
    write(6,'(*(i3))') lmap

    !Write dimensions
    write(ch,'(*(i4))') cK,cL,zhetdim,shetdim,hetdim,sdhetdim,mobhetdim,inihetdim

    !write muw
    do tt=1,cX
       do ii=1,cK
          write(ch,'(*(f15.8))') (par%muw(kmap(ii),lmap(jj),tt), jj=1,cL)
       end do
    end do

    !write sigma
    do tt=1,cXs
       do ii=1,cK
          write(ch,'(*(f15.8))') (par%sigmaw(kmap(ii),lmap(jj),tt), jj=1,cL)
       end do
    end do

    !write gam
    do tt=1,mobhetdim
       do ii=1,cK
          write(ch,'(*(f15.8))') (par%gam(kmap(ii),lmap(jj),tt), jj=1,cL)
       end do
    end do

    !write lam
    do tt=1,mobhetdim
       do ii=1,cK
          write(ch,'(*(f15.8))') (par%lam(kmap(ii),lmap(jj),tt), jj=1,cL)
       end do
    end do

    !write psi
    do tt=1,mobhetdim
       do ii=1,cK
          write(ch,'(*(f15.8))') (par%psi(kmap(ii),lmap(jj),tt), jj=1,cL)
       end do
    end do

    !write delta
    do tt=1,mobhetdim
       do ii=1,cK
          write(ch,'(*(f15.8))') (par%del(kmap(ii),lmap(jj),tt), jj=1,cL)
       end do
    end do

    !write piw
    do tt=1,zhetdim
       write(ch,'(*(f15.8))') (par%piw(tt,kmap(ii)),ii=1,cK)
    end do

    !write pif
    do tt=1,shetdim
       write(ch,'(*(f15.8))') (par%pif(tt,lmap(jj)),jj=1,cL)
    end do

    !write m (initial distribution)
    do tt=1,inihetdim
       do ii=1,cK
          write(ch,'(*(f15.8))') (par%m(kmap(ii),lmap(jj),tt), jj=0,cL)
       end do
    end do

    !write q
    write(ch,'(*(f15.8))') (par%q(lmap(jj)),jj=1,cL) !notice: only writing 1:L. Q includes 0 index that is by default set to 1.

    !write pk
    write(ch,'(*(f15.8))') (par%pk(kmap(ii)),ii=1,cK) !In an earlier version this was par%p

    !write pz (marginal z distribution)
    write(ch,'(*(f15.8))') (par%pz(jj),jj=1,zhetdim)

    !write ps (marginal s distribution)
    write(ch,'(*(f15.8))') (par%ps(jj),jj=1,shetdim)

    !write rho
    write(ch,'(f15.8)') par%rho

    !write MM
    do tt=1,mobhetdim
       do k=1,cK
          do ii=0,cL
             write(ch,'(*(f15.8))') (par%MM(kmap(k),lmap(ii),lmap(jj),tt), jj=0,cL)
          end do
       end do
    end do

    !write Mbar
    do tt=1,mobhetdim
       do k=1,cK
          write(ch,'(*(f15.8))') (par%Mbar(kmap(k),lmap(jj),tt), jj=0,cL)
       end do
    end do

    !write p(k,l,x)
    do tt=1,cXs
       do ii=1,cK
          write(ch,'(*(f15.8))') (p(kmap(ii),lmap(jj),tt), jj=0,cL)
       end do
    end do

    !write Var(w|x) !8 category empirical wage variance.
    write(ch,'(*(f15.8))') (varwx(ii), ii=1,cX)
    
    !write a
    write(ch,'(*(f15.8))') (ak(ii), ii=1,cK)

    !write b
    write(ch,'(*(f15.8))') (bl(jj), jj=1,cL)
    
  end subroutine writemodelpar_fix
end module datacollect
